// file      : xsd-frontend/parser.hxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2005-2006 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#ifndef XSD_FRONTEND_PARSER_HXX
#define XSD_FRONTEND_PARSER_HXX

#include <cult/types.hxx>

#include <xsd-frontend/semantic-graph/schema.hxx>

namespace XSDFrontend
{
  using namespace Cult::Types;

  struct InvalidSchema {};

  class Parser: public NonCopyable
  {
  public:
    ~Parser ();

    Parser ();

  public:
    // Throws InvalidSchema in case of a failure.
    //
    Evptr<SemanticGraph::Schema>
    parse (SemanticGraph::Path const& schema);

  private:
    class Impl;
    Evptr<Impl> impl_;
  };
}

#endif  // XSD_FRONTEND_PARSER_HXX
